package cn.iocoder.yudao.module.ecw.service.node;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.ecw.controller.admin.node.vo.*;
import cn.iocoder.yudao.module.ecw.dal.dataobject.node.NodeDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 服务网点 Service 接口
 *
 * @author wlh
 */
public interface NodeService {

    /**
     * 创建服务网点
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createNode(@Valid NodeCreateReqVO createReqVO);

    /**
     * 更新服务网点
     *
     * @param updateReqVO 更新信息
     */
    void updateNode(@Valid NodeUpdateReqVO updateReqVO);

    /**
     * 删除服务网点
     *
     * @param id 编号
     */
    void deleteNode(Long id);

    /**
     * 获得服务网点
     *
     * @param id 编号
     * @return 服务网点
     */
    NodeDO getNode(Long id);

    /**
     * 获得服务网点列表
     *
     * @param ids 编号
     * @return 服务网点列表
     */
    List<NodeDO> getNodeList(Collection<Long> ids);

    /**
     * 获得服务网点分页
     *
     * @param pageReqVO 分页查询
     * @return 服务网点分页
     */
    PageResult<NodeDO> getNodePage(NodePageReqVO pageReqVO);

    PageResult<NodeDO> getNodePageList(NodePageReqVO pageReqVO);

    /**
     * 获得服务网点列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 服务网点列表
     */
    List<NodeDO> getNodeList(NodeExportReqVO exportReqVO);

}
